package dev.peerat.parser.java.builder;

import java.util.ArrayList;
import java.util.List;

import dev.peerat.parser.Token;
import dev.peerat.parser.java.Annotation;
import dev.peerat.parser.java.Class;
import dev.peerat.parser.java.JavaElement;

public class JavaClassBuilder extends JavaModifiableBuilder<JavaClassBuilder, dev.peerat.parser.java.Class>{

	private List<Annotation> annotations;
	private String name;
	private String extend;
	private String implement;
	
	private List<JavaElement> elements;
	
	public JavaClassBuilder annotate(JavaAnnotationBuilder annotation){
		if(this.annotations == null) this.annotations = new ArrayList<>();
		this.annotations.add(annotation.build());
		return this;
	}
	
	public JavaClassBuilder setName(String name){
		this.name = name;
		return this;
	}
	
	public JavaClassBuilder extend(String type){
		this.extend = type;
		return this;
	}
	
	public JavaClassBuilder implement(String type){
		if(implement == null) this.implement = type;
		else this.implement+=","+type;
		return this;
	}
	
	public <T extends JavaElement> JavaClassBuilder element(JavaBuilder<T> builder){
		if(this.elements == null) this.elements = new ArrayList<>();
		this.elements.add(builder.build());
		return this;
	}
	
	@Override
	public Class build(){
		dev.peerat.parser.java.Class result = new dev.peerat.parser.java.Class(this.annotations, this.mod, new Token(0,0,name, null), extend == null ? null : new Token(0,0,extend, null), implement == null ? null : new Token(0,0, implement, null));
		if(elements != null) result.getElements().addAll(elements);
		return result;
	}

}
